import { ErrorMessageType } from "./error-message-type.exception";
import { ErrorMessageParams } from "./error-message-params.exception";
/**
 * This class is the error message
 */
export declare class ErrorMessage {
    code: string;
    message: string;
    type: ErrorMessageType;
    parameters: Array<ErrorMessageParams>;
    /**
     * Public constructor
     */
    constructor();
    /**
     * @param code the code to set
     */
    setCode(code: string): void;
    /**
     * @return the code
     */
    getCode(): string;
    /**
     * @param message the message to set
     */
    setMessage(message: string): void;
    /**
     * @return the message
     */
    getMessage(): string;
    /**
     * @param type the type to set
     */
    setType(type: ErrorMessageType): void;
    /**
     * @return the type
     */
    getType(): ErrorMessageType;
    /**
     * @param parameters the parameters to set
     */
    setParameters(parameters: Array<ErrorMessageParams>): void;
    /**
     * @return the parameters
     */
    getParameters(): ErrorMessageParams[];
    /**
     * @return the object as string
     */
    toString(): string;
}
