import { ErrorMessage } from './error-message.exception';
/**
 * This class is the errors to handle this type of errors
 */
export declare class Errors {
    status: number;
    messages: Array<ErrorMessage>;
    /**
     * Public constructor
     * @param status with the status code
     */
    constructor(status: number);
    /**
     * @param status the status to set
     */
    setStatus(status: number): void;
    /**
     * @return the status
     */
    getStatus(): number;
    /**
     * @param messages the messages to set
     */
    setMessages(messages: Array<ErrorMessage>): void;
    /**
     * @return the messages
     */
    getMessages(): ErrorMessage[];
    /**
     * @return the object as string
     */
    toString(): string;
    /**
     * @param statusCode with the status code
     * @param jsonContent with the JSON Content
     * @return a new instance of errors
     */
    static parse(statusCode: number, jsonContent: any): Errors;
    /**
     * @param messagesJsonArray with the array of messages of JSON
     * @return an array of instances of this class
     */
    static parseMessages(messagesJsonArray: any): any[];
    /**
     * @param messageParamsJsonArray with the array of message parameters of JSON
     * @return an array of instances of this class
     */
    static parseMessageParams(messageParamsJsonArray: any): any[];
}
