import { ErrorMessage } from './error-message.exception';
import { ErrorMessageParams } from './error-message-params.exception';
/**
 * This class is the errors to handle this type of errors
 */
var /**
 * This class is the errors to handle this type of errors
 */
Errors = /** @class */ (function () {
    /**
     * Public constructor
     * @param status with the status code
     */
    function Errors(status) {
        this.status = status;
    }
    /**
     * @param status the status to set
     */
    /**
         * @param status the status to set
         */
    Errors.prototype.setStatus = /**
         * @param status the status to set
         */
    function (status) {
        this.status = status;
    };
    /**
     * @return the status
     */
    /**
         * @return the status
         */
    Errors.prototype.getStatus = /**
         * @return the status
         */
    function () {
        return this.status;
    };
    /**
     * @param messages the messages to set
     */
    /**
         * @param messages the messages to set
         */
    Errors.prototype.setMessages = /**
         * @param messages the messages to set
         */
    function (messages) {
        this.messages = messages;
    };
    /**
     * @return the messages
     */
    /**
         * @return the messages
         */
    Errors.prototype.getMessages = /**
         * @return the messages
         */
    function () {
        return this.messages;
    };
    /**
     * @return the object as string
     */
    /**
         * @return the object as string
         */
    Errors.prototype.toString = /**
         * @return the object as string
         */
    function () {
        return JSON.stringify(this, null, 4);
    };
    /**
     * @param statusCode with the status code
     * @param jsonContent with the JSON Content
     * @return a new instance of errors
     */
    /**
         * @param statusCode with the status code
         * @param jsonContent with the JSON Content
         * @return a new instance of errors
         */
    Errors.parse = /**
         * @param statusCode with the status code
         * @param jsonContent with the JSON Content
         * @return a new instance of errors
         */
    function (statusCode, jsonContent) {
        // Generate a new instance of Errors
        var outcome = new Errors(statusCode);
        var messagesInstance = null;
        if (jsonContent != null && jsonContent != "undefined" && jsonContent.messages != null && jsonContent.messages != "undefined") {
            messagesInstance = Errors.parseMessages(jsonContent.messages);
        }
        // Set the messages
        outcome.setMessages(messagesInstance);
        return outcome;
    };
    /**
     * @param messagesJsonArray with the array of messages of JSON
     * @return an array of instances of this class
     */
    /**
         * @param messagesJsonArray with the array of messages of JSON
         * @return an array of instances of this class
         */
    Errors.parseMessages = /**
         * @param messagesJsonArray with the array of messages of JSON
         * @return an array of instances of this class
         */
    function (messagesJsonArray) {
        var messagesArrayInstance = [];
        var messagesArrayJsonLength = messagesJsonArray.length;
        for (var i = 0; i < messagesArrayJsonLength; i++) {
            var errorMessage = new ErrorMessage();
            errorMessage.setCode(messagesJsonArray[i].code);
            errorMessage.setMessage(messagesJsonArray[i].message);
            errorMessage.setType(messagesJsonArray[i].type);
            var errorMessageParams = null;
            if (messagesJsonArray[i].parameters != null && messagesJsonArray[i].parameters != "undefined") {
                errorMessageParams = Errors.parseMessageParams(messagesJsonArray[i].parameters);
            }
            errorMessage.setParameters(errorMessageParams);
            // Set the error message to the array
            messagesArrayInstance[i] = errorMessage;
        }
        return messagesArrayInstance;
    };
    /**
     * @param messageParamsJsonArray with the array of message parameters of JSON
     * @return an array of instances of this class
     */
    /**
         * @param messageParamsJsonArray with the array of message parameters of JSON
         * @return an array of instances of this class
         */
    Errors.parseMessageParams = /**
         * @param messageParamsJsonArray with the array of message parameters of JSON
         * @return an array of instances of this class
         */
    function (messageParamsJsonArray) {
        var messageParamsArrayInstance = [];
        var messageParamsJsonArrayLength = messageParamsJsonArray.length;
        for (var i = 0; i < messageParamsJsonArrayLength; i++) {
            var errorMessageParams = new ErrorMessageParams();
            errorMessageParams.setName(messageParamsJsonArray[i].name);
            messageParamsArrayInstance[i] = errorMessageParams;
        }
        return messageParamsArrayInstance;
    };
    return Errors;
}());
/**
 * This class is the errors to handle this type of errors
 */
export { Errors };
;
//# sourceMappingURL=errors.exception.js.map